=== debian/changelog ===
coccinelle (1.0.4.deb-2) unstable; urgency=medium

  * Run tests only when building architecture-dependant packages
    (closes: #806611)

 -- Євгеній Мещеряков <eugen@debian.org>  Thu, 24 Dec 2015 14:54:31 +0100

coccinelle (1.0.4.deb-1) unstable; urgency=medium

  * New upstream release
  * Remove disable-spgen.diff - fixed upstream

 -- Євгеній Мещеряков <eugen@debian.org>  Thu, 05 Nov 2015 22:13:05 +0100
